var execFile = require('child_process').execFile;
var env = require('./env');

function connectToCachedNetwork(ssid, config, callback) {
  var cmd = 'netsh';
  var params = ['wlan', 'connect', `ssid=${ssid}`, `name=${ssid}`];
  if (config.iface) {
    params.push('interface="' + config.iface + '"');
  }
  execFile(
    cmd,
    params,
    { env },
    function(err) {
      callback && callback(err);
    }
  )
}

module.exports = function(config) {
  return function(ssid, callback) {
    if (callback) {
      connectToCachedNetwork(ssid, config, callback);
    } else {
      return new Promise(function(resolve, reject) {
        connectToCachedNetwork(ssid, config, function(err, result) {
          if (err) {
            reject(err);
          } else {
            resolve(result);
          }
        });
      });
    }
  };
};
