var execFile = require('child_process').execFile;
var env = require('./env');

function getCached(config, callback) {
  var cmd = 'netsh';
  var params = ['wlan', 'show', 'profiles'];
  execFile(cmd, params, { env }, (err, res) => {
    if (err) {
      return callback(err);
    }
    try {
      var cached = res
        .toString('utf8')
        .split('\r')
        .join('')
        .split('\n')
        .filter(x => x && x.includes(' : '))
        .map(x => x.split(' : '))
        .filter(x => x[1] && x[1] !== '')
        .map(x => x[1].trim());
      callback(null, cached);
    } catch (e) {
      console.error(e);
      callback(null, []);
    }
  });
}

module.exports = function(config) {
  return function(callback) {
    if (callback) {
      getCached(config, callback);
    } else {
      return new Promise(function(resolve, reject) {
        getCached(config, function(err, result) {
          if (err) {
            reject(err);
          } else {
            resolve(result);
          }
        });
      });
    }
  };
};
